// FILENAME: Server_Campaign.cs
//
//Server running the campaign maps


exec(serverLocation);
//-------------------------------------------------
//  RC file to start a server automatically
//-------------------------------------------------

//-------------------------------------------------
// Edit the parameters of this file to configure
// your server options. Use notepad, not a word
// processor. File must be saved as text only.
//-------------------------------------------------

//-------------------------------------------------
// Type the name for your server inside the quotes
// Must be less then 22 characters
//-------------------------------------------------
$server::Hostname =                                strcat("Campaign maps");

//-------------------------------------------------
// Password Protection. Leave blank for none.
// Quotes optional.
//-------------------------------------------------
$server::Password =                                 "";

//-------------------------------------------------
// Maximum player limit. 16 is highest recommended.
//-------------------------------------------------
$server::MaxPlayers =                              8;

//-------------------------------------------------
// Number of kills before server cycles.
// If zero, kills are never reset.
//-------------------------------------------------
$server::FragLimit =                               1;

//-------------------------------------------------
// Time limit in minutes before server cycles.
// Must be a positive integer.
//-------------------------------------------------
$server::TimeLimit =                               2;

//-------------------------------------------------
// Mass limit per player
// Must be a positive integer or zero for no limit.
//-------------------------------------------------
$server::MassLimit =                                0;

//-------------------------------------------------
// Combat Value limit per player
// Must be a positive integer or zero for no limit.
//-------------------------------------------------
$server::CombatValueLimit =                         0;

//-------------------------------------------------
// Team play options. TeamPlay false =  deathmatch.
// TeamPlay true = teams
//-------------------------------------------------
$server::TeamPlay =                                FALSE;

//-------------------------------------------------
// Team Mass limit - valid only when teamPlay is true
// Must be a positive integer or zero for no limit.
//-------------------------------------------------
$server::TeamMassLimit =                            0;

//-------------------------------------------------
// Team Combat Value Limit - valid only when teamPlay is true
// Must be a positive integer or zero for no limit.
//-------------------------------------------------
$server::TeamCombatValueLimit =                     0;

//-------------------------------------------------
// Tech Level Limit
// Must be a positive integer less then or
// equal to 128 or zero for no limit.
//-------------------------------------------------
$server::TechLevelLimit =                          0;

//-------------------------------------------------
// Drop In Progress
// Does server allow drop in progress??
//-------------------------------------------------
$server::DropInProgress =                            TRUE  ;

$server::AllowMixedTech =                            TRUE  ;
$server::FactoryVehOnly =                           FALSE  ;

//-------------------------------------------------
// Mission rotation list. This is the order the
// worlds will cycle in a game with either the frag
// or time limits set.
//-------------------------------------------------
$MissionCycling::Stage0 =                          "CDes01";    // Cyb/ce2
$MissionCycling::Stage1 =                          "CDes02";    // Cyb/ce3
$MissionCycling::Stage2 =                          "CDes03";    // Cyb/ce4
$MissionCycling::Stage3 =                          "CIce01";    // Cyb/cc1
$MissionCycling::Stage4 =                          "CIce02";    // Cyb/cc2
$MissionCycling::Stage5 =                          "CIce03";    // Cyb/cc
$MissionCycling::Stage6 =                          "CinDes01";  // Cyb/cin_ce
$MissionCycling::Stage7 =                          "CinMar01";  // Hum/cin_ha
$MissionCycling::Stage8 =                          "CinMar02";  // Hum/cin_hb
$MissionCycling::Stage9 =                          "CinMar03";  // Hum/cin_hb3
$MissionCycling::Stage10 =                         "CinMar04";  // Hum/cin_hc
$MissionCycling::Stage11 =                         "CinMer01";  // Cyb/cin_ca
$MissionCycling::Stage12 =                         "CinMer02";  // Cyb/cin_cb
$MissionCycling::Stage13 =                         "CinPlu01";  // Hum/cin_he2
$MissionCycling::Stage14 =                         "CinTem01";  // Cyb/cin_cd
$MissionCycling::Stage15 =                         "CinTit01";  // Hum/cin_hd
$MissionCycling::Stage16 =                         "CinTit02";  // Hum/cin_he
$MissionCycling::Stage17 =                         "CMar01";    // hum/ha0
$MissionCycling::Stage18 =                         "CMar02";    // hum/ha1
$MissionCycling::Stage19 =                         "CMar03";    // hum/ha2
$MissionCycling::Stage20 =                         "CMar04";    // hum/ha3
$MissionCycling::Stage21 =                         "CMar05";    // hum/ha4
$MissionCycling::Stage22 =                         "CMar06";    // hum/ha5
$MissionCycling::Stage23 =                         "CMar07";    // hum/ha6
$MissionCycling::Stage24 =                         "CMar08";    // hum/hb1
$MissionCycling::Stage25 =                         "CMar09";    // hum/hb3
$MissionCycling::Stage26 =                         "CMar10";    // hum/hb4
$MissionCycling::Stage27 =                         "CMer01";    // cyb/ca0
$MissionCycling::Stage28 =                         "CMer02";    // cyb/ca1
$MissionCycling::Stage29 =                         "CMer03";    // cyb/ca2
$MissionCycling::Stage30 =                         "CMer04";    // cyb/ca3
$MissionCycling::Stage31 =                         "CMer05";    // cyb/ca4
$MissionCycling::Stage32 =                         "CPlu01";    // hum/he1
$MissionCycling::Stage33 =                         "CPlu02";    // hum/he2
$MissionCycling::Stage34 =                         "CPlu03";    // hum/he3
$MissionCycling::Stage35 =                         "CTem01";    // cyb/cd1
$MissionCycling::Stage36 =                         "CTem02";    // cyb/cd3
$MissionCycling::Stage37 =                         "CTem03";    // cyb/cd4
$MissionCycling::Stage38 =                         "CTit01";    // hum/hd1
$MissionCycling::Stage39 =                         "CTit02";    // hum/hd2
$MissionCycling::Stage40 =                         "CVen01";    // hum/hc1
$MissionCycling::Stage41 =                         "CVen02";    // hum/hc2
$MissionCycling::Stage42 =                         "CVen03";    // hum/hc3

//-------------------------------------------------
// Start mission. Defines which mission from the
// rotation list the server starts on.
//-------------------------------------------------
$server::Mission =                                  $MissionCycling::Stage0;

// These items will be allowed by default -- your mission script can change these
// by calling allowVehicle, allowComponent, or allowWeapon
function setAllowedItems()
{
	//Vehicles
	exec("defaultVehicles.cs");
	allowComponent(                                    all,      TRUE  );
	allowWeapon(                                       all,      TRUE  );
}


function onMissionStart()
{
  %nowDate = getDate();
  %nowTime = getTime();
  %outputString =  %nowDate @ ", " @ %nowTime @ " -- " @ "server start";
  fileWrite("multiplayer\\serverlog.txt", append, %outputString);

  $startTime = getCurrentTime();
}

function player::OnAdd(%player)
{
  %player.name = getName(%player);
  %player.location = 0;
  %player.startTime = getCurrentTime();

  %nowDate = getDate();
  %nowTime = getTime();
  %player.IP = getConnection(%player);
  %outputString =  %nowDate @ ", " @ %nowTime @ " -- " @ %player.name @ " joined the game (" @ %player.IP @ ")";

  fileWrite("multiplayer\\serverlog.txt", append, %outputString);

}


function player::OnRemove(%player)
{
  %player.name = getName(%player);
  %nowDate = getDate();
  %nowTime = getTime();
  %timeEnd = getCurrentTime();
  %timeIn = timeDifference( %timeEnd, %player.startTime);
  %outputString =  %nowDate @ ", " @ %nowTime @ " -- " @ %player.name @ " left the game (" @ %player.IP @ ") -- " @ %timeIn;

  fileWrite("multiplayer\\serverlog.txt", append, %outputString);
}